package com.esignlive.guidance.forum;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.List;

import javax.net.ssl.HttpsURLConnection;

import org.json.JSONException;
import org.json.JSONObject;


public class _02_13_rest_create_invisible_signature {

	private final String apiKey = "your_api_key";
	private final String requestURL = "https://sandbox.esignlive.com/api";

	private final List<String> documentIdList = new ArrayList<String>() {
		{
			add("default-consent");
			add("Doc1");
		}
	};

	public String createPackage() throws MalformedURLException, IOException, JSONException {
		String charset = "UTF-8";
		File uploadFile1 = new File("your_file_path");
		String boundary = Long.toHexString(System.currentTimeMillis());
		String CRLF = "\r\n"; // Line separator used in multipart/form-data.
		String jsonContent = "{\"roles\":[{\"id\":\"Owner\",\"signers\":[{\"email\":\"liangduo1993@gmail.com\",\"firstName\":\"duo\",\"lastName\":\"liang\",\"company\":\"OneSpan Sign\"}]},{\"id\":\"Role1\",\"signers\":[{\"email\":\"esign_signer1@mailinator.com\",\"firstName\":\"1.firstname\",\"lastName\":\"1.lastname\",\"company\":\"OneSpan Sign\"}]},{\"id\":\"Role2\",\"signers\":[{\"email\":\"esign_signer2@mailinator.com\",\"firstName\":\"2.firstname\",\"lastName\":\"2.lastname\",\"company\":\"OneSpan Sign\"}]}],\"documents\":[{\"approvals\":[{\"role\":\"Role1\",\"fields\":[{\"page\":0,\"top\":100,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\"}]},{\"role\":\"Role2\",\"fields\":[{\"page\":0,\"top\":300,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\"}]},{\"role\":\"Owner\",\"fields\":[{\"page\":0,\"top\":0,\"subtype\":\"FULLNAME\",\"height\":0,\"left\":0,\"width\":0,\"type\":\"SIGNATURE\"},{\"id\":\"myLabelField\",\"value\":\"Some common value for all signers\",\"top\":200,\"left\":100,\"width\":250,\"height\":50,\"page\":0,\"type\":\"INPUT\",\"subtype\":\"LABEL\"}]}],\"name\":\"Test Document\",\"id\":\"Doc1\"}],\"name\":\"Example Package\",\"type\":\"PACKAGE\",\"language\":\"en\",\"emailMessage\":\"\",\"description\":\"New Package\",\"autocomplete\":true,\"status\":\"SENT\"}";

		HttpsURLConnection connection = null;
		URL url = new URL(requestURL + "/packages");
		connection = (HttpsURLConnection) url.openConnection();
		connection.setDoOutput(true);
		connection.setDoInput(true);
		connection.setRequestMethod("POST");
		connection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
		connection.setRequestProperty("Authorization", "Basic " + apiKey);
		connection.setRequestProperty("Accept", "application/json; esl-api-version=11.0");
		OutputStream output = connection.getOutputStream();
		PrintWriter writer = new PrintWriter(new OutputStreamWriter(output, charset), true);

		try {
			// Add pdf file.
			writer.append("--" + boundary).append(CRLF);
			System.out.println(uploadFile1.getName());
			writer.append("Content-Disposition: form-data; name=\"file\"; filename=\"" + uploadFile1.getName() + "\"")
					.append(CRLF);
			writer.append(CRLF).flush();
			Files.copy(uploadFile1.toPath(), output);
			output.flush();
			writer.append(CRLF).flush();

			// add json payload
			writer.append("--" + boundary).append(CRLF);
			writer.append("Content-Disposition: form-data; name=\"payload\"").append(CRLF);
			writer.append("Content-Type: application/json; charset=" + charset).append(CRLF);
			writer.append(CRLF).append(jsonContent).append(CRLF).flush();

			// End of multipart/form-data.
			writer.append("--" + boundary + "--").append(CRLF).flush();
		} catch (IOException ex) {
			System.err.println(ex);
		}

		// get and write out response code
		int responseCode = ((HttpURLConnection) connection).getResponseCode();
		System.out.println(responseCode);
		if (responseCode == 200) {
			// get and write out response
			BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
			String inputLine;
			StringBuffer response = new StringBuffer();

			while ((inputLine = in.readLine()) != null) {
				response.append(inputLine);
			}
			in.close();
			System.out.println(response.toString());
			return new JSONObject(response.toString()).getString("id");
		} else {
			// get and write out response
			BufferedReader in = new BufferedReader(new InputStreamReader(connection.getErrorStream()));
			String inputLine;
			StringBuffer response = new StringBuffer();
			while ((inputLine = in.readLine()) != null) {
				response.append(inputLine);
			}
			in.close();
			System.out.println(response.toString());
			return "";
		}
	}

	public void signForOwner(String packageId) throws IOException, JSONException {
		StringBuilder sb = new StringBuilder(1000);
		sb.append("{\"documents\": [" );
		for (String docId : documentIdList) {
			sb.append("{\"id\": \""+docId+"\"},");
		}
		sb.deleteCharAt(sb.lastIndexOf(","));
		sb.append("]}");
				
		String payload = sb.toString();
		String url = requestURL + "/packages/"+packageId+"/documents/signed_documents";
		doPost(url, payload);	

	}

	public void doPost(String url, String payloadJSON) throws IOException, JSONException {
		System.out.println("do post: " + url + ";payload: " + payloadJSON);
		URL sourceClient = new URL(url);
		HttpURLConnection sourceConn = (HttpURLConnection) sourceClient.openConnection();
		sourceConn.setRequestProperty("Authorization", "Basic " + apiKey);
		sourceConn.setRequestProperty("Content-Type", "application/json; esl-api-version=11.21");
		sourceConn.setRequestProperty("Accept", "application/json; esl-api-version=11.21");
		sourceConn.setRequestProperty("Accept-Encoding", "UTF-8");
		sourceConn.setRequestProperty("Accept-Charset", "UTF-8");

		sourceConn.setRequestMethod("POST");
		sourceConn.setDoOutput(true);
		sourceConn.setDoInput(true);

		OutputStream os = sourceConn.getOutputStream();
		os.write(payloadJSON.getBytes(StandardCharsets.UTF_8));
		os.flush();
		os.close();

		int sourceResponseCode = ((HttpURLConnection) sourceConn).getResponseCode();
		Reader ir = (sourceResponseCode >= 200 && sourceResponseCode <= 299)
				? new InputStreamReader(sourceConn.getInputStream())
				: new InputStreamReader(sourceConn.getErrorStream());
		BufferedReader in = new BufferedReader(ir);
		String inputLine;
		StringBuffer response = new StringBuffer();

		while ((inputLine = in.readLine()) != null) {
			response.append(inputLine);
		}

		in.close();
		sourceConn.disconnect();

		System.out.println("Status: " + sourceResponseCode + ";Response: " + response.toString());

	}

	public static void main(String[] args) throws MalformedURLException, IOException, JSONException {
		_02_13_rest_create_invisible_signature instance = new _02_13_rest_create_invisible_signature();

		String packageId = instance.createPackage();
		instance.signForOwner(packageId);
		
		
	}

}